import os
import data
from vines import Vine
from enemies import *
from triggers import *
from infobox import *

class Template:
    def initialize(self):
        enemies = []
        vines = []
        special = []
        return enemies, vines, special


class Levels:
    def get_levels(self):
        levels = [Level0(), Level1(), Level2(), Level3(), Level4(), Level5(), Level6(), 
                  Level7(), Level8(), Level9(), Level10(), Level11(), Level12(), 
                  Level13(), Level14(), Level15(), Level16(), Level17(), Level18(),
                  Level19(), Level20(), Level21(), 
                  LevelFinal(), LevelFinalFinal(), LevelFinalFinalFinal(), LevelFinalFinalFinalFinal(),
                  LevelYouShallNotPass()]

        return levels
        
class Level0:
    def initialize(self):
        enemies = []
        vines = []
        special = [InfoBox((220, 220), "Rayzan - King of the Strings"), \
                   InfoBox((220, 300), "by: graner, mosillan and phren"), \
                   InfoBox((220, 380), "For PyWeek 7"), \
                   InfoBox((570, 140), "UP - Climb"), \
                   InfoBox((570, 220), "SPACE - Jump"), \
                   InfoBox((570, 300), "SPACE while airborne - Grab"), \
                   InfoBox((570, 380), "DOWN - Slide down"), \
                   InfoBox((570, 460), "YOU - Have fun!")]
        return enemies, vines, special

class Level1:
    def initialize(self):
        enemies = [Arrow(Vector(800, 300), TriggerWhenPlayerGoesByVertically(350), Vector(-0.3, 0.0))]
        vines = []
        special = [InfoBox((190, 75), "Bananas give you energy to try again!"),
                   InfoBox((600, 200), "Arrows are DANGEROUS!"),
                   InfoBox((600, 400), "Dodging is NOT optional!")]
        return enemies, vines, special
	
class Level2:
    def initialize(self):
        enemies = [Arrow(Vector(0, 160), TriggerWhenPlayerGoesByVertically(250), Vector(0.4, 0.0)),
                   Arrow(Vector(800, 250), TriggerWhenPlayerGoesByVertically(350), Vector(-0.4, 0.0))]
        vines = []
        special = [InfoBox((240, 150), "Arrows are deadly in pairs.")]
        return enemies, vines, special
    
class Level3:
    def initialize(self):
        enemies = [Arrow(Vector(0, 300), TriggerWhenPlayerGoesByVertically(350), Vector(0.4, 0.0)),
                   Arrow(Vector(0, 320), TriggerWhenPlayerGoesByVertically(350), Vector(0.4, 0.0)),
                   Arrow(Vector(800, 250), TriggerWhenPlayerGoesByVertically(300), Vector(-0.2, 0.0)),
                   Arrow(Vector(0, 150), TriggerWhenPlayerGoesByVertically(200), Vector(0.5, 0.0))]
        vines = []
        special = [InfoBox((550, 200), "...and huge groups!")]
        return enemies, vines, special

class Level4:
    def initialize(self):
        enemies = []
        vines = [Vine(Vector(200, 220), 200)]
        special = [InfoBox((220, 160), "This is a vine!"),
                   InfoBox((200, 450), "You can jump to it and swing."),
                   InfoBox((200, 500), "Remember to grab though!"),
                   InfoBox((270, 550), "(SPACE)"),
                   InfoBox((570, 200), "LEFT - look left."),
                   InfoBox((570, 250), "LEFT + SPACE - jump left."),
                   InfoBox((570, 300), "SPACE while swinging - Jump"),
                   InfoBox((565, 450), "Jumping right is the same,"),
                   InfoBox((620, 500), "but it wouldn't be very smart here...")]
                   
        return enemies, vines, special
 
class Level5:
    def initialize(self):
        enemies = [Anvil(Vector(400,0), TriggerWhenPlayerGoesByVertically(450))]
        vines = [Vine(Vector(250, 250), 200)]
        special = [InfoBox((230,150), "Anvils are DANGEROUS too!")]
        return enemies, vines, special 
    
class Level6:
    def initialize(self):
        enemies = [BananaPickup(Vector(640, 210))]
        vines = [Vine(Vector(550, 100), 150)]
        special = [InfoBox((640, 300), "Bananas are for monkeys"),
                   InfoBox((640, 350), "...yeah, YOU!")]
        return enemies, vines, special
    
class Level7:
    def initialize(self):
        enemies = [Anvil(Vector(400,30), TriggerWhenPlayerGoesByVertically(250)),
                   Anvil(Vector(400,70), TriggerWhenPlayerGoesByVertically(500)),
                   Anvil(Vector(250,356), TriggerWhenPlayerGoesByHorizontally(200))]
        vines = [Vine(Vector(550, 100), 200),
                 Vine(Vector(250, 375), 200)]
        special = [InfoBox((180, 100), "Beware, now there are 3 anvils!!")]
        return enemies, vines, special
    
class Level8:
    def initialize(self):
        enemies = [Anvil(Vector(400,0), TriggerWhenPlayerGoesByVertically(400)),
                   Anvil(Vector(400,0), TriggerWhenPlayerGoesByVertically(500)),
                   Anvil(Vector(300,0), TriggerWhenPlayerGoesByHorizontally(200)),
                   Anvil(Vector(200,0), TriggerWhenPlayerGoesByHorizontally(300)),
                   Anvil(Vector(400,0), TriggerWhenPlayerGoesByHorizontally(600)),
                   Anvil(Vector(500,0), TriggerWhenPlayerGoesByHorizontally(450)),
                   Anvil(Vector(180,0), TriggerWhenPlayerGoesByHorizontally(150)),
                   Anvil(Vector(200,0), TriggerWhenPlayerGoesByHorizontally(130)),
                   Anvil(Vector(370,0), TriggerWhenPlayerGoesByVertically(200)),
                   Anvil(Vector(430,0), TriggerWhenPlayerGoesByVertically(200))
                   ]
        vines = [Vine(Vector(550, 200), 200),
                 Vine(Vector(230, 325), 200),
                 Vine(Vector(180, 150), 100)]
        special = [InfoBox((180, 100), "Beware, now there are 10 anvils!!!"),
                   InfoBox((610, 550), "Vine-to-Vine jumping might help!")]
        return enemies, vines, special
    
class Level9:
    def initialize(self):
        enemies = [Fly(Vector(250,190), Vector(0.1,0.0), 300),
                   Fly(Vector(200,400))]
        vines = [Vine(Vector(250, 250), 200)]
        special = [InfoBox((200,150), "Eww, flies carrying diseases!"),
                   InfoBox((230,200), "Watch out!")]
        return enemies, vines, special

class Level10:
    def initialize(self):
        
        enemies = []
        for i in range(0,25):
            enemies.append(Arrow(Vector(0,i*20), TriggerWhenPlayerGoesByVertically((i*20)+25), Vector(0.5, 0.0)))
        vines = []
        special = [InfoBox((240, 150), "Holy.. You better hurry!!!")]
        return enemies, vines, special
    
class Level11:
    def initialize(self):
        enemies = [Fly(Vector(250,150), Vector(0.0,0.12), 300),
                   Fly(Vector(550,450), Vector(0.0,-0.12), 300),
                   Anvil(Vector(400,30), TriggerWhenPlayerGoesByVertically(500)),
                   Anvil(Vector(400,30), TriggerWhenPlayerGoesByHorizontally(250)),
                   Anvil(Vector(400,30), TriggerWhenPlayerGoesByHorizontally(550)),
                   BananaPickup(Vector(150, 175))]
        vines = [Vine(Vector(250, 50), 200),
                 Vine(Vector(250, 350), 200), Vine(Vector(550, 350), 200)]
        special = []
        return enemies, vines, special

class Level12:
    def initialize(self):
        enemies = [Anvil(Vector(300,280), TriggerWhenPlayerGoesByHorizontally(300)),
                   Anvil(Vector(400,0), TriggerWhenPlayerGoesByVertically(450)),
                   BananaPickup(Vector(150, 400))]
        vines = [Vine(Vector(300, 300), 200),
                 Vine(Vector(150, 300), 200)]
        special = [InfoBox((230,150), "Watch where you swing!!")]
        return enemies, vines, special 

class Level13:
    def initialize(self):
        enemies = [Fly(Vector(200,150), Vector(0.1, 0.0), 300),
                   Fly(Vector(600,450), Vector(-0.1, 0.0), 300),
                   Anvil(Vector(400, 30), TriggerWhenPlayerGoesByVertically(300))]
        vines = [Vine(Vector(600, 200), 200)]
        special = []
        return enemies, vines, special

class Level14:
    def initialize(self):
        enemies = [Bird(2000, Vector(150, 100), Vector(0.1, 0.0), 500)]
        vines = [Vine(Vector(250, 200), 250),
                 Vine(Vector(530, 180), 280),]
        special = [InfoBox((250, 150), "Birds are DANGEROUS!"),
                   InfoBox((550, 150), "AND EVIL!"),
                   InfoBox((580, 550), "We shit you not!")]
        return enemies, vines, special
    
class Level15:
    def initialize(self):
        enemies = [Bird(2000, Vector(470 ,100), Vector(0.08, 0.0), 100),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(400))]
        vines = [Vine(Vector(500,200), 200)]
        special = []
        return enemies, vines, special
    
class Level16:
    def initialize(self):
        enemies = []
        for x in range (30, 300, 30):
            enemies.append(Anvil(Vector(400, 300-x), TriggerWhenPlayerGoesByVertically(500-x)))
        vines = [Vine(Vector(250, 250), 250),
                 Vine(Vector(550, 150), 200)]
        special = [InfoBox((600, 500), "There are not enough anvils!")]
        return enemies, vines, special
    
class Level17:
    def initialize(self):
        enemies = []
        for x in range (50, 550, 50):
            enemies.append(Fly(Vector(100, x), Vector(0.1, 0.0), 800-x))
        vines = []
        special = []
        return enemies, vines, special
   
class Level18:
    def initialize(self):
        enemies = [Bird(300, Vector(150, 250), Vector(0.1, 0.0), 150),
                   Bird(300, Vector(500, 250), Vector(0.1, 0.0), 100),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(400)),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(250)),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(150))]
        vines = [Vine(Vector(250, 300), 100),
                 Vine(Vector(550, 350), 100)]
        special = []
        return enemies, vines, special
    
class Level19:
    def initialize(self):
        enemies = [Fly(Vector(300, 300), Vector(0.1, 0.0), 200),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(200)),
                   Arrow(Vector(800, 250), TriggerWhenPlayerGoesByVertically(250), Vector(-0.3, 0.0))]
        vines = [Vine(Vector(620, 300), 150)]
        special = []
        return enemies, vines, special
    
class Level20:
    def initialize(self):
        enemies = [Arrow(Vector(800, 360), TriggerWhenPlayerGoesByHorizontally(200), Vector(-0.15, 0.0)),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(500)),
                   Arrow(Vector(0, 300), TriggerWhenPlayerGoesByVertically(320), Vector(0.5, 0.0)),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByVertically(320)),
                   Arrow(Vector(800, 300), TriggerWhenPlayerGoesByHorizontally(600), Vector(-0.1, 0.0)),
                   Anvil(Vector(400, 0), TriggerWhenPlayerGoesByHorizontally(600)),
                   Anvil(Vector(530, 0), TriggerWhenPlayerGoesByHorizontally(530))]
        vines = [Vine(Vector(250, 260), 180),
                 Vine(Vector(530, 50), 300)]
        special = []
        return enemies, vines, special

class Level21:
    def initialize(self):
        enemies = [Fly(Vector(200,150), Vector(0.1, 0.0), 300),
                   Fly(Vector(600,450), Vector(-0.1, 0.0), 300),
                   Fly(Vector(300,200), Vector(0.1, 0.1), 400),
                   Anvil(Vector(400, 30), TriggerWhenPlayerGoesByVertically(300))]
        vines = [Vine(Vector(600, 200), 200)]
        special = []
        return enemies, vines, special
    
class LevelFinal:
    def initialize(self):
        enemies = []
        vines = []
        special = [HugeInfoBox((400,300), "The end of the string is in another castle.")]
        return enemies, vines, special

class LevelFinalFinal:
    def initialize(self):
        enemies = []
        for x in range(200, 400, 100):
            for y in range(300, 600, 100):
                enemies.append(BananaPickup(Vector(x, y)))
        for x in range(500, 700, 100):
            for y in range(300, 600, 100):
                enemies.append(BananaPickup(Vector(x, y)))
        vines = []
        special = [HugeInfoBox((400, 200), "Bonus level!")]
        return enemies, vines, special
 
class LevelFinalFinalFinal:
    def initialize(self):
        enemies = []
        vines = []
        special = [HugeInfoBox((400, 300), "I bet you suicided for those bananas!")]
        return enemies, vines, special 

class LevelFinalFinalFinalFinal:
    def initialize(self):
        enemies = []
        vines = []
        special = [HugeInfoBox((400, 300), "It keeps going, and going, and going...")]
        return enemies, vines, special
    
class LevelYouShallNotPass:
    def initialize(self):
        enemies = []
        vines = []
        special = [HugeInfoBox((400, 300), "You shall not pass!")]
        return enemies, vines, special
